%%%%% Stopbehav Tracking Version analysis program
%%%% works with stopbehavOSX
%%%%% Must load desired program first
%%%%% for use with stopsig_new (JRC 7/25/07)

LEFT = 95;  %change key assignments
RIGHT= 92;  % change key assignments
%LEFT = input('Enter LEFT key (e.g. 197 for <): ');
%RIGHT = input('Enter RIGHT key (e.g. 198 for >): ');

%%%% reads in the scans

filename=input('Enter behavioral filename: ','s');	
start_step=1;
end_step=16; %loads what step to end with

load(filename);
tmp = zeros(256,16);

tmp(1:256,:)=Seeker;
clear Seeker,
Seeker = tmp;

%%%% Make SSD graphs

a = max(Ladder1);
b = max(Ladder2);
ymax=max([a b]);
a = min(Ladder1);
b = min(Ladder2);
ymin=min([a b]);
if ymin>0,
	ymin=0;
end;


xmax=length(Ladder1)+1;

for a=1:size(Ladder1),
	Ladder1Plot(2*a-1)=Ladder1(a);
	Ladder2Plot(2*a-1)=Ladder2(a);
	Ladder1Plot(2*a)=Ladder1(a);
	Ladder2Plot(2*a)=Ladder2(a);
end;



subplot(2,2,1);
for a=1:size(Ladder1)-1;
	hold on;
	plot(a:a+1,Ladder1Plot(2*a-1:2*a), 'b');
	plot([a+1 a+1],Ladder1Plot(2*a:2*a+1), 'b');
end;
axis([1 xmax ymin ymax]);
subplot(2,2,2);
for a=1:size(Ladder2)-1;
	hold on;
	plot(a:a+1,Ladder2Plot(2*a-1:2*a), 'b');
	plot([a+1 a+1],Ladder2Plot(2*a:2*a+1), 'b');
end;
axis([1 xmax ymin ymax]);


%%%% Actual Analysis...

%calculates median, mean, and stdev looking specifically at the range of
%steps that the user specifies
GRTmedian=median(Seeker(find((Seeker(:,1)>(start_step-1)*16 & Seeker(:,1)<= end_step*16) & ((Seeker(:,3)==0 & Seeker(:,4)==0 & Seeker(:,7)==LEFT)|(Seeker(:,3)==0 & Seeker(:,4)==1 & Seeker(:,7)==RIGHT))),9))*1000;
GRTmean=mean(Seeker(find((Seeker(:,1)>(start_step-1)*16 & Seeker(:,1)<= end_step*16) & ((Seeker(:,3)==0 & Seeker(:,4)==0 & Seeker(:,7)==LEFT)|(Seeker(:,3)==0 & Seeker(:,4)==1 & Seeker(:,7)==RIGHT))),9))*1000;
StDevGRT=std(Seeker(find((Seeker(:,1)>(start_step-1)*16 & Seeker(:,1)<= end_step*16) & ((Seeker(:,3)==0 & Seeker(:,4)==0 & Seeker(:,7)==LEFT)|(Seeker(:,3)==0 & Seeker(:,4)==1 & Seeker(:,7)==RIGHT))),9))*1000;

BOTT=length(Ladder1)-16+start_step; TOP=length(Ladder1)-16+end_step; % looks at range of steps the user specifies
Ladder1mean=mean(Ladder1(BOTT:TOP));
Ladder2mean=mean(Ladder2(BOTT:TOP));
DimErrors=sum((Seeker(:,3)==0 & ( (Seeker(:,4)==0 & Seeker(:,7)==RIGHT) | ( Seeker(:,4)==1 & Seeker(:,7)==LEFT ) )));
SSDfifty=mean([Ladder1mean Ladder2mean]);
SSRT=GRTmedian-SSDfifty;

% Percent Inhibition from bottom to top (so last 8 steps); do separately
% for each ladder and then average
for ladder=1:2,
    tmp=Seeker(find(Seeker(:,5)==ladder),:);
    tmp2=tmp(start_step:end_step,:); % chooses only the steps of the ladder that the user requests to look at
    PctInhib(ladder)=100*sum(tmp2(:,7)==0)/min(size(tmp2));
end;

%Analysis to get SSRT using quantile based on actual PctInhib as opposed to assuming 50% like above
corr_rt=Seeker(find((Seeker(:,1)>(start_step-1)*16 & Seeker(:,1)<= end_step*16) & ((Seeker(:,3)==0 & Seeker(:,4)==0 & Seeker(:,7)==LEFT)|(Seeker(:,3)==0 & Seeker(:,4)==1 & Seeker(:,7)==RIGHT))),9)*1000;
GRTquant=quantile(corr_rt,mean(PctInhib)/100);
SSRTquant=GRTquant-SSDfifty;

%calculates how many GO trials they responded to to make sure the subject
%is actually doing the task
percent_responded = (sum(Seeker(:,3)==0 & Seeker(:,7) ~= 0) / sum(Seeker(:,3)==0));

%fprintf('Median Go Reaction Time (ms): %f\n',GRTmedian);
fprintf('Median Go Reaction Time at Pct inhib (ms): %0.1f\n',GRTquant);
%fprintf('Mean Go Reaction Time (ms): %f\n',GRTmean);
%fprintf('Mean SSD Ladder 1 (ms): %f\n',Ladder1mean);
%fprintf('Mean SSD Ladder 2 (ms): %f\n',Ladder2mean);
fprintf('Number of discrimination errors: %0.f\n',DimErrors);
%fprintf('Subject SSRT assuming 50 Pct inhib (ms): %f\n', SSRT);
%fprintf('Subject SSRT using actual Pct inhib (ms): %f\n', SSRTquant);
%fprintf('Subject SSDcent (ms): %f\n', SSDfifty);
%fprintf('Percent Inhibition Ladder 1: %0.1f\n',PctInhib(1));
%fprintf('Percent Inhibition Ladder 2: %0.1f\n',PctInhib(2));
%fprintf('Percent go trials answered: %.1f\n', percent_responded*100);

% Print relevant output to screen

 %   fprintf('%0.0f\t%0.0f\t%0.1f\t%0.1f\t%0.1f\t%0.1f\t%0.1f\t%0.1f\t%d\t%0.1f\t%0.1f\t%0.1f\t%0.1f\t%0.3f\n',start_step, end_step, GRTmedian, GRTquant, StDevGRT, Ladder1mean, Ladder2mean, SSDfifty, DimErrors, SSRT, SSRTquant, PctInhib, percent_responded);
